; select Md =[0.485] model
; Input: mk_Tab1.xdr and fxdr files of Md models
;  Av_gaia/1.086 = vtauv=tauvGaia* :Av computed fomr Gaia distance
;  data(0) = Av_gaia / ebv_ref       : rel reddening  is stored in xdr  file
;  tauv   = best fitt using only E(B-V) as constrain
; Output:
; ft<Md>  = tauv/tauvGaia
; c<Md>      = chi2 in JHK reddening fro
;

restore, './Input/mk_Tab1.xdr', /verb
nn        = n_elements(star)
Av_gaia   = vtauv*2.5/alog(10.)
tauv_Gaia = vtauv
fxdr      = findfile('./ResultEbv/HD*.xdr', cou=nf)
vtauv_md  =  fltarr(nn)
if nf ne nn then stop, 'check star', fxdr

for i       = 0, nn-1 do begin
 restore, fxdr(i)
 vtauv_Md(i) = tauv
endfor

; Compute Lumdistances with

Av_md    = vtauv_md *2.5/alog(10.)
ds_Md    = 10.^((5. + Vk - Mv      - Av_md)/5.)
ds0_Md   = 10.^((5. + Vk - Mv -eMv - Av_md)/5.) ; kleine Entfernung
ds1_Md   = 10.^((5. + Vk - Mv +eMv - Av_md)/5.) ; grosse Entfernung


plot, dp, ds/dp, xtitle='D!UGaia!N', ytitle='D!Us!N / D!UGaia!n', psym=plotsym(/box, scale=1.15)
oplot, dp, ds_md/dp, psym=plotsym(/box, color=fsc_color('red'), scale=1.15)

save, filename='DlumMd.xdr', /xdr, star, fxdr, vtauv_md, Av_md, Av_Gaia, $
      ds_md, ds0_md, ds1_md, dp


print, 'DLumMd done : see DLumMd.xdr'




end
