Pro pl_DL2DGcorMd
; plot luminosity distance versus ZP corrected GAIAparallax
; V=dwarfs, IV=subgiants, III=giants, II=bright giants, I=hyper giants
; Comments : 47 stars
; ------
;


!p.font=0
!p.charsize =1.3
!p.thick =2
    window, 0, xsi=600, ysize=700
    setps


; Read mk_Tab1 and set ds = ds_mod and re-compute error in ds_mod

restore, './Input/mk_Tab1.xdr', /verb
Av_gaia = vtauv*2.5/alog(10.)
nn      = n_elements(star)
ds_ref  = ds
ds0_mod = ds0 * 10^((Av - vtauv*2.5/alog(10.)) /5.)
ds1_mod = ds1 * 10^((Av - vtauv*2.5/alog(10.)) /5.)
ds0     = ds0_mod
ds1     = ds1_mod

print, ' User Ds_mod with vtauv of Eq.2 and Ds_md assumin Md=50% '
restore, /verb, 'DlumMd.xdr'

ds      = ds_md

d_err0 = sqrt((ds - ds0)^2 + (edp/2.)^2)
d_err1 = sqrt((ds - ds1)^2 + (edp/2.)^2)

dserr1 = abs(ds - ds1)

rsg     = ds/Dp
is      = sort(rsg)

rsg25   = rsg(is(9))
rsg75   = rsg(is(24))
rsgmed  = median(rsg)

print, ' Ds_Md40 / Dgaia : lower upper quartile and median of rsg = ', rsg25, rsg75, rsgmed






;  --------  all stars --------
;
iiu    = where(rsg ge 1.)
iil    = where(rsg le 1.) 

;  --------  Only dwarfs lc =5 V stars  --------
;
ii5    = where(lc eq 5 or lc eq 4, nn5)
ii5_b  = where(lc eq 5 or lc eq 4 and sc ge 10 and sc lt 14,nn5_B ) 
ii5_b4 = where(lc eq 5 or lc eq 4 and sc ge 14,nn5_B4 ) 
ii5_o  = where(lc eq 5 or lc eq 4 and sc lt 10,nn5_O ) 

ii3    = where(lc eq 3, nn3) & print, nn5
ii3_b  = where(lc eq 3 and sc ge 10 and sc lt 14,nn3_B ) 
ii3_b4 = where(lc eq 3 and sc ge 14,nn3_B4 ) 
ii3_o  = where(lc eq 3 and sc lt 10,nn3_O ) 
; 2sig detections:
ii3_b_2s  = where(lc eq 3 and sc ge 10 and sc lt 14 and (rsg ge 1 and ( (ds-2.*abs(ds-ds0))/Dp) ge 1),nn3_B_2s ) 
ii3_b4_2s = where(lc eq 3 and sc ge 14 and (rsg ge 1 and ( (ds-2.*abs(ds-ds0))/Dp) ge 1),nn3_B4_2s ) 
ii3_o_2s  = where(lc eq 3 and sc lt 10 and (rsg ge 1 and ( (ds-2.*abs(ds-ds0))/Dp) ge 1),nn3_O_2s ) 

ii1    = where(lc gt 5, nn1)
ii1_b  = where(lc gt 5 and sc ge 10 and sc lt 14,nn1_B ) 
ii1_b4 = where(lc gt 5 and sc ge 14,nn1_B4 ) 
ii1_o  = where(lc gt 5 and sc lt 10,nn1_O )

ii1_b_2s  = where(lc gt 5 and sc ge 10 and sc lt 14 and (rsg ge 1 and ( (ds-2.*abs(ds-ds0))/Dp) ge 1),nn1_B_2s ) 
ii1_b4_2s = where(lc gt 5 and sc ge 14 and (rsg ge 1 and ( (ds-2.*abs(ds-ds0))/Dp) ge 1),nn1_B4_2s ) 
ii1_o_2s  = where(lc gt 5 and sc lt 10 and (rsg ge 1 and ( (ds-2.*abs(ds-ds0))/Dp) ge 1),nn1_O_2s ) 


; 3sig detections:
ii5_b_3s  = where(lc eq 5 or lc eq 4 and sc ge 10 and sc lt 14 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn5_B_3s ) 
ii5_b4_3s = where(lc eq 5 or lc eq 4 and sc ge 14 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn5_B4_3s ) 
ii5_o_3s  = where(lc eq 5 or lc eq 4 and sc lt 10 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn5_O_3s ) 

ii3_b_3s  = where(lc eq 3 and sc ge 10 and sc lt 14 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn3_B_3s ) 
ii3_b4_3s = where(lc eq 3 and sc ge 14 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn3_B4_3s ) 
ii3_o_3s  = where(lc eq 3 and sc lt 10 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn3_O_3s ) 


ii1_b_3s  = where(lc gt 5 and sc ge 10 and sc lt 14 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn1_B_3s ) 
ii1_b4_3s = where(lc gt 5 and sc ge 14 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn1_B4_3s ) 
ii1_o_3s  = where(lc gt 5 and sc lt 10 and (rsg ge 1 and ( (ds-3.*abs(ds-ds0))/Dp) ge 1),nn1_O_3s ) 


; check number of stars:
print, '  V stars: ', nn5_o+nn5_b+nn5_b4;, nn5
print, 'III stars: ', nn3_o+nn3_b+nn3_b4;, nn3
print, '  I stars: ', nn1_o+nn1_b+nn1_b4;, nn1
print,' all stars: ', nn5+nn3+nn1;, nn


;stop, 'bis hier'

; ------------  Ratio
plot, Dp, rsg,  psym=4,  /nodata, $
      xr=[0, 2600.], yr=[0.4, 2.], /xsty,/ysty, xthick=4, ythick=4

polyfill, [0.,0.,2600., 2600.], [rsg25, rsg75,rsg75, rsg25], Color=FSC_Color('light cyan')
;oplot, [0., 2600], [1.36, 1.36], thick=2,color=fsc_color('gray')
;oplot, [0., 2600], [1.06, 1.06], thick=2, color=fsc_color('gray')

oplot, [0., 2600], [1.0, 1.0],  thick=2 ; , color=fsc_color('gray')


; PLot median of Ebv model fit
oplot, [0., 2600], [rsgmed,rsgmed], thick=2, linesty=2 ;, color=fsc_color('gray')


xyouts, 2400, rsg75-0.03, '75%', charsize =0.6
xyouts, 2400, rsg25+0.01, '25%', charsize =0.6




; error bars along y-axis
for i =0, nn-1 do if(sc(i) ge 10 and sc(i) lt 14) then oplot, [Dp(i), Dp(i)], [ds(i)-d_err0(i), ds(i)+d_err1(i)]/Dp(i), thick=1, color=fsc_color('blue')
for i =0, nn-1 do if(sc(i) lt 10) then oplot, [Dp(i), Dp(i)], [ds(i)-d_err0(i), ds(i)+d_err1(i)]/Dp(i),thick=1, color=fsc_color('orange')
for i =0, nn-1 do if(sc(i) ge 14) then oplot, [Dp(i), Dp(i)], [ds(i)-d_err0(i), ds(i)+d_err1(i)]/Dp(i), thick=1, color=fsc_color('green')


for i =0, nn-1 do if(sc(i) ge 10 and sc(i) lt 14) then oploterror, Dp(i), rsg(i), eDp(i), rsg(i)*0., psym=3, /nohat, thick=1, color=fsc_color('blue')
for i =0, nn-1 do if(sc(i) lt 10)                 then oploterror, Dp(i), rsg(i), eDp(i), rsg(i)*0., psym=3, /nohat, thick=1, color=fsc_color('orange')
for i =0, nn-1 do if(sc(i) ge 14)                 then oploterror, Dp(i), rsg(i), eDp(i), rsg(i)*0., psym=3, /nohat, thick=1, color=fsc_color('green')


oplot, Dp(ii5_b),  ds(ii5_b)/Dp(ii5_b),    psym=plotsym(/superstar, /fill, scale=1.3, color=fsc_color('blue'))

oplot, Dp(ii5_o),  ds(ii5_o)/Dp(ii5_o),    psym=plotsym(/superstar, /fill, scale=1.3, color=fsc_color('orange'))

oplot, Dp(ii5_b4), ds(ii5_b4)/Dp(ii5_b4),  psym=plotsym(/superstar, /fill, scale=1.3, color=fsc_color('green'))

oplot, Dp(ii1_b), ds(ii1_b)/Dp(ii1_b), psym=plotsym(/box, /fill, scale=1.3, color=fsc_color('blue'))
oplot, Dp(ii1_o), ds(ii1_o)/Dp(ii1_o), psym=plotsym(/box, /fill, scale=1.3, color=fsc_color('orange'))


oplot, Dp(ii3_b),  ds(ii3_b)/Dp(ii3_b),    psym=plotsym(/circle, /fill, scale=1.3, color=fsc_color('blue'))
oplot, Dp(ii3_o),  ds(ii3_o)/Dp(ii3_o),    psym=plotsym(/circle, /fill, scale=1.3, color=fsc_color('orange'))

oplot, Dp(ii3_b4), ds(ii3_b4)/Dp(ii3_b4),  psym=plotsym(/circle, /fill, scale=1.3, color=fsc_color('green'))

oplot, Dp(ii1), ds(ii1)/Dp(ii1), psym=plotsym(/box, scale=1.3)
oplot, Dp(ii3), ds(ii3)/Dp(ii3), psym=plotsym(/circle, scale=1.3)
oplot, Dp(ii5), ds(ii5)/Dp(ii5), psym=plotsym(/superstar, scale=1.3)


; 3 sigma:

if nn5_O_3s  gt 0 then oplot, Dp(ii5_o_3s),  ds(ii5_o_3s)/Dp(ii5_o_3s),    psym=plotsym(/superstar, /fill, scale=2.5, color=fsc_color('orange'))
if nn5_B_3s  gt 0 then oplot, Dp(ii5_b_3s),  ds(ii5_b_3s)/Dp(ii5_b_3s),    psym=plotsym(/superstar, /fill, scale=2.5, color=fsc_color('blue'))
if nn5_B4_3s gt 0 then oplot, Dp(ii5_b4_3s), ds(ii5_b4_3s)/Dp(ii5_b4_3s),  psym=plotsym(/superstar, /fill, scale=2.5, color=fsc_color('green'))

if nn3_O_3s  gt 0 then oplot, Dp(ii3_o_3s),  ds(ii3_o_3s)/Dp(ii3_o_3s),    psym=plotsym(/circle, /fill, scale=2.5, color=fsc_color('orange'))
if nn3_B_3s  gt 0 then oplot, Dp(ii3_b_3s),  ds(ii3_b_3s)/Dp(ii3_b_3s),    psym=plotsym(/circle, /fill, scale=2.5, color=fsc_color('blue'))
if nn3_B4_3s gt 0 then oplot, Dp(ii3_b4_3s), ds(ii3_b4_3s)/Dp(ii3_b4_3s),  psym=plotsym(/circle, /fill, scale=2.5, color=fsc_color('green'))

if nn1_O_3s  gt 0 then oplot, Dp(ii1_o_3s),  ds(ii1_o_3s)/Dp(ii1_o_3s),    psym=plotsym(/box, /fill, scale=2.5, color=fsc_color('orange'))
if nn1_B_3s  gt 0 then oplot, Dp(ii1_b_3s),  ds(ii1_b_3s)/Dp(ii1_b_3s),    psym=plotsym(/box, /fill, scale=2.5, color=fsc_color('blue'))

; rand:
if nn5_O_3s  gt 0 then oplot, Dp(ii5_o_3s),  ds(ii5_o_3s)/Dp(ii5_o_3s),    psym=plotsym(/superstar,  scale=2.5)
if nn5_B_3s  gt 0 then oplot, Dp(ii5_b_3s),  ds(ii5_b_3s)/Dp(ii5_b_3s),    psym=plotsym(/superstar,  scale=2.5)
if nn5_B4_3s gt 0 then oplot, Dp(ii5_b4_3s), ds(ii5_b4_3s)/Dp(ii5_b4_3s),  psym=plotsym(/superstar,  scale=2.5)

if nn3_O_3s  gt 0 then oplot, Dp(ii3_o_3s),  ds(ii3_o_3s)/Dp(ii3_o_3s),    psym=plotsym(/circle,  scale=2.5)
if nn3_B_3s  gt 0 then oplot, Dp(ii3_b_3s),  ds(ii3_b_3s)/Dp(ii3_b_3s),    psym=plotsym(/circle,  scale=2.5)
if nn3_B4_3s gt 0 then oplot, Dp(ii3_b4_3s), ds(ii3_b4_3s)/Dp(ii3_b4_3s),  psym=plotsym(/circle,  scale=2.5)

if nn1_O_3s  gt 0 then oplot, Dp(ii1_o_3s),  ds(ii1_o_3s)/Dp(ii1_o_3s),    psym=plotsym(/box,  scale=2.5)
if nn1_B_3s  gt 0 then oplot, Dp(ii1_b_3s),  ds(ii1_b_3s)/Dp(ii1_b_3s),    psym=plotsym(/box,  scale=2.5)



legend, ['O4  -  O9', 'B0  -  B3', 'B4  -  A0'], charsize=1.2, charthick=6, $
        textcolor=[fsc_color('orange'), fsc_color('blue'), fsc_color('green')]


x=0.024
oplot, [1510.,1510], [1.96-x,1.96-x], psym=plotsym(/box, scale=1)
oplot, [1510.,1510], [1.91-x,1.91-x], psym=plotsym(/circle, scale=1)
oplot, [1510.,1510], [1.86-x,1.86-x], psym=plotsym(/superstar, scale=1)


x=0.04  ; x+50
xyouts, 1580, 1.96 -x, 'Supergiants I', charsize=1.1
xyouts, 1580, 1.91 -x, 'Giants III', charsize=1.1
xyouts, 1580, 1.86 -x, 'Dwarfs V-IV', charsize=1.1



; oplot, dp, ds_mod/dp, psym=plotsym(/circle, /fill, scale=0.5)
; oplot, dp, ds_mod/dp, psym=plotsym(/star, /fill, scale=1.5)



;ii = where(rsg lt 0.92, nEH)


;for l =0, nEH-1 do print, format='(i6, f7.2, a10)', nint(dp(ii(l))+40.), rsg(ii(l)) +0.01, star(ii(l))     


;for l =0, nEH-1 do if star(ii(l)) ne 'HD112607' then xyouts, dp(ii(l))+40., rsg(ii(l)) +0.01, star(ii(l)), charsize=0.9


plot, Dp, rsg, /nodata, /noerase, $
      xr=[0, 2600.], yr=[0.4, 2.], /xsty,/ysty, xthick=4, ythick=4, $
      xtitle = '!3D!DGaia !N (pc)', ytitle = 'D!dL!N(A!DV!N) / !3D!DGaia !N'


; --------------

endps

   print
   com =  ' ps2pdf                  idl.ps     DL2DGcorMd.pdf'
   spawn, com
   print, ' Result of reddening fit in plot :  DL2DGcorMd.pdf'
   print, com + '     ->      DONE'

end
